public class PREPCatPerformanceDashboardController
{

    public Integer iniMonth {get;set;}
    public Integer iniYear {get;set;}

    public Boolean renderOutput {get;set;}

    public List<spendToMarket> spendToMarketRows {get;set;}
    public List<negSavings> negSavingsRows {get;set;}
    public List<realSavings> realSavingsRows {get;set;}
    public List<stepSeven> stepSevenRows {get;set;}
    public List<stepFive> stepFiveRows {get;set;}
    public List<stepOnetoFour> stepOnetoFourRows {get;set;}

    public List<selectOption> disc {get;set;}
    public String selectedDisc {get;set;}

    public List<selectOption> cat {get;set;}
    public String selectedCat {get;set;}

    public List<PREP_Baseline__c> baselineListY {get;set;}
    public List<PREP_Baseline__c> baselineListYM {get;set;}
    public List<PREP_Baseline__c> baselineListYTD {get;set;}
    public List<PREP_Business_Value_Submission__c> bvsList {get;set;}
    public List<PREP_Business_Value_Spend_Schedule__c> bvsScheList {get;set;}
    public List<PREP_Business_Value_Spend_Schedule_Month__c> bvsScheMonthList {get;set;}
    public List<PREP_Business_Value_Sav_Schedule_Month__c> bvsScheSavMonthList {get;set;}

    List<String> iniListY {get;set;}
    List<String> iniListYM {get;set;}
    List<String> iniListYTD {get;set;}
    List<String> bvsIdList {get;set;}
    List<String> bvsScheIdList {get;set;}
    List<String> bvsScheMonthIdList {get;set;}

    public String statusLight {get;set;}


    public PREPCatPerformanceDashboardController() 
    {
        
    }

    public void processRecords()
    {

        if(iniYear != null)
        {

            if(selectedDisc == 'All' && selectedCat == 'All')
            {

                createSpendToMarket(0, selectedDisc, selectedCat);
                createNegSavings(0, selectedDisc, selectedCat);
                createRealSavings(0, selectedDisc, selectedCat);
                createStepOnetoFour(0, selectedDisc, selectedCat);
                createStepFive(0, selectedDisc, selectedCat);
                createStepSeven(0, selectedDisc, selectedCat);

                renderOutput = true;
                System.debug('All Initiative');

            }

            else if(selectedDisc != 'All' && selectedCat == 'All')
            {
                createSpendToMarket(1, selectedDisc, selectedCat);
                createNegSavings(1, selectedDisc, selectedCat);
                createRealSavings(1, selectedDisc, selectedCat);
                createStepOnetoFour(1, selectedDisc, selectedCat);
                createStepFive(1, selectedDisc, selectedCat);
                createStepSeven(1, selectedDisc, selectedCat);
                System.debug('Disc Specific');

            }

            else if(selectedDisc != 'All' && selectedCat != 'All')
            {
                createSpendToMarket(2, selectedDisc, selectedCat);
                createNegSavings(2, selectedDisc, selectedCat);
                createRealSavings(2, selectedDisc, selectedCat);
                createStepOnetoFour(2, selectedDisc, selectedCat);
                createStepFive(2, selectedDisc, selectedCat);
                createStepSeven(2, selectedDisc, selectedCat);
                System.debug('Cat Specific');
            }

        }
        
    }

    public void autoRun()
    {
        disc = new List<selectOption>();
        cat = new List<selectOption>();

        disc.add(new selectOption('All', 'All'));

        for(PREP_Discipline__c d : [SELECT Name FROM PREP_Discipline__c])
        {
            disc.add(new selectOption(d.Name, d.Name));
        }

        cat.add(new selectOption('All', 'All'));

        for(PREP_Category__c c : [SELECT Name FROM PREP_Category__c])
        {
            cat.add(new selectOption(c.Name, c.Name));
        }
    }

    public void createSpendToMarket(Integer level, String discEntered, String catEntered)
    {
        Id projectID = Schema.SObjectType.PREP_Baseline__c.getRecordTypeInfosByName().get('Projects Baseline').getRecordTypeId();
        Id LprojectID = Schema.SObjectType.PREP_Baseline__c.getRecordTypeInfosByName().get('Locked Projects Baseline').getRecordTypeId();

        spendToMarketRows = new List<spendToMarket>();
        baselineListY = new List<PREP_Baseline__c>();
        baselineListYM = new List<PREP_Baseline__c>();
        baselineListYTD = new List<PREP_Baseline__c>();
        bvsList = new List<PREP_Business_Value_Submission__c>();
        bvsScheList = new List<PREP_Business_Value_Spend_Schedule__c>();
        bvsScheMonthList = new List<PREP_Business_Value_Spend_Schedule_Month__c>();

        bvsIdList = new List<String>();
        bvsScheIdList = new List<String>();

        iniListY = new List<String>();
        iniListYM = new List<String>();
        iniListYTD = new List<String>();

        Decimal targetAnnual = 0;
        Decimal targetMonth = 0;
        Decimal actualMonth = 0;
        Decimal targetYTD = 0;
        Decimal actYTDSpend = 0;

        Date YTD_Start = date.newinstance(iniYear, 01, 01);
        Date YTD_End;

        if(iniMonth == 12)
        {
            YTD_End = date.newinstance(iniYear+1, 01, 01);
        }

        else
        {
            YTD_End = date.newinstance(iniYear, (iniMonth+1), 01);
        }

        if(level == 0)
        {
            baselineListY = [SELECT Name, RecordTypeId, Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND CALENDAR_MONTH(Forecast_Date_05__c) = :iniMonth 
            AND CALENDAR_YEAR(Forecast_Date_05__c) = :iniYear AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c WHERE CALENDAR_YEAR(X05_Going_To_Market__c) = :iniYear 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
            
            baselineListYM = [SELECT Baseline_Spend_Dollar_Target__c, Initiative_Id__c
            FROM PREP_Baseline__c WHERE CALENDAR_YEAR(X05_Going_To_Market__c) = :iniYear 
            AND CALENDAR_MONTH(X05_Going_To_Market__c) = :iniMonth 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND Forecast_Date_05__c >= :YTD_Start AND Forecast_Date_05__c < :YTD_End AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c 
            WHERE X05_Going_To_Market__c >= :YTD_Start AND X05_Going_To_Market__c < :YTD_End 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
        }

        else if(level == 1)
        {
            baselineListY = [SELECT Name, RecordTypeId, Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND CALENDAR_MONTH(Forecast_Date_05__c) = :iniMonth 
            AND CALENDAR_YEAR(Forecast_Date_05__c) = :iniYear AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND CALENDAR_YEAR(X05_Going_To_Market__c) = :iniYear 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
            
            baselineListYM = [SELECT Baseline_Spend_Dollar_Target__c, Initiative_Id__c
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND CALENDAR_YEAR(X05_Going_To_Market__c) = :iniYear 
            AND CALENDAR_MONTH(X05_Going_To_Market__c) = :iniMonth 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND Forecast_Date_05__c >= :YTD_Start AND Forecast_Date_05__c < :YTD_End AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND X05_Going_To_Market__c >= :YTD_Start AND X05_Going_To_Market__c < :YTD_End 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
        }


        else if(level == 2)
        {
            baselineListY = [SELECT Name, RecordTypeId, Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND CALENDAR_MONTH(Forecast_Date_05__c) = :iniMonth 
            AND CALENDAR_YEAR(Forecast_Date_05__c) = :iniYear AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND Category__c = :catEntered AND 
            CALENDAR_YEAR(X05_Going_To_Market__c) = :iniYear 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
            
            baselineListYM = [SELECT Baseline_Spend_Dollar_Target__c, Initiative_Id__c
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND Category__c = :catEntered AND 
            CALENDAR_YEAR(X05_Going_To_Market__c) = :iniYear AND CALENDAR_MONTH(X05_Going_To_Market__c) = :iniMonth 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND Forecast_Date_05__c >= :YTD_Start AND Forecast_Date_05__c < :YTD_End AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND Category__c = :catEntered AND 
            X05_Going_To_Market__c >= :YTD_Start AND X05_Going_To_Market__c < :YTD_End 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
        }

        for(PREP_Baseline__c baselineY : baselineListY)
        {

            targetAnnual = targetAnnual + baselineY.Baseline_Spend_Dollar_Target__c;

            for(PREP_Initiative_Status_Update__c ISU : baselineY.Material_Group_Status_Summaries__r)
            {
                actualMonth = actualMonth + ISU.Forecast_Spend_Dollar_Total__c;
            }

            iniListY.add(baselineY.Initiative_Id__c);
        }

        for(PREP_Baseline__c baselineYM : baselineListYM)
        {
            targetMonth = targetMonth + baselineYM.Baseline_Spend_Dollar_Target__c;
            iniListYM.add(baselineYM.Initiative_Id__c);
        }

        bvsList = [SELECT Id FROM PREP_Business_Value_Submission__c WHERE Initiative_Id__c in :iniListY AND Status__c = 'Approved'];

        for(PREP_Business_Value_Submission__c BVS : bvsList)
        {
            bvsIdList.add(BVS.Id);
        }

        bvsScheList = [SELECT Id FROM PREP_Business_Value_Spend_Schedule__c WHERE Business_Value_Submission_Id__c in :bvsIdList];
        

        for(PREP_Business_Value_Spend_Schedule__c BVSS : bvsScheList)
        {
            bvsScheIdList.add(BVSS.Id);
        }

        bvsScheMonthList = [SELECT Id, MonthNumber__c, Scheduled_Spend__c, Year__c FROM PREP_Business_Value_Spend_Schedule_Month__c WHERE Business_Value_Spend_Schedule_Id__c in :bvsScheIdList];

        for(PREP_Business_Value_Spend_Schedule_Month__c BVSSM : bvsScheMonthList)
        {
            if(BVSSM.Year__c != null)
            {
                Integer bvssmYear = Integer.valueOf(BVSSM.Year__c);

                if(BVSSM.MonthNumber__c == iniMonth && bvssmYear == iniYear)
                {
                    actualMonth = actualMonth + BVSSM.Scheduled_Spend__c;
                }
            }
        }


        bvsList.clear();
        bvsScheList.clear();
        bvsScheMonthList.clear();
        bvsIdList.clear();
        bvsScheIdList.clear();

        bvsList = [SELECT Id FROM PREP_Business_Value_Submission__c WHERE Initiative_Id__c in :iniListYTD AND Status__c = 'Approved'];

        if(bvsList.size() > 0)
        {
            for(PREP_Business_Value_Submission__c BVS : bvsList)
            {
                bvsIdList.add(BVS.Id);
            }

            bvsScheList = [SELECT Id FROM PREP_Business_Value_Spend_Schedule__c WHERE Business_Value_Submission_Id__c in :bvsIdList];
            

            for(PREP_Business_Value_Spend_Schedule__c BVSS : bvsScheList)
            {
                bvsScheIdList.add(BVSS.Id);
            }

            bvsScheMonthList = [SELECT Id, MonthNumber__c, Scheduled_Spend__c, Year__c FROM PREP_Business_Value_Spend_Schedule_Month__c WHERE Business_Value_Spend_Schedule_Id__c in :bvsScheIdList];

            for(PREP_Business_Value_Spend_Schedule_Month__c BVSSM : bvsScheMonthList)
            {
                if(BVSSM.Year__c != null)
                {
                    Integer bvssmYear = Integer.valueOf(BVSSM.Year__c);

                    if(BVSSM.MonthNumber__c <= iniMonth && bvssmYear == iniYear)
                    {
                        actYTDSpend = actYTDSpend + BVSSM.Scheduled_Spend__c;
                    }
                }
            }
        }


        else
        {
            for(PREP_Baseline__c baselineYTD : baselineListYTD)
            {
                targetYTD = targetYTD + baselineYTD.Baseline_Spend_Dollar_Target__c;

                for(PREP_Initiative_Status_Update__c ISU : baselineYTD.Material_Group_Status_Summaries__r)
                {
                    actYTDSpend = actYTDSpend + ISU.Forecast_Spend_Dollar_Total__c;
                }

                iniListYTD.add(baselineYTD.Initiative_Id__c);
            }
        }


        Decimal statusDiff = (targetYTD - actYTDSpend);
        Decimal sPercent = 0;
        Decimal statusDiffPercent = 0;

        if(targetYTD == 0)
        {
            sPercent = 0;
            statusDiffPercent = 100 - (sPercent*100);

        }

        else
        {
            sPercent = (statusDiff / targetYTD);
            statusDiffPercent = 100 - (sPercent*100);

        }

        if(statusDiffPercent >= 95)
        {
            statusLight = '<img src="/resource/BPC_Icons/green.png" alt="Schedule Status" border="0"/>';
        }

        else if(statusDiffPercent < 95 && statusDiffPercent >= 90)
        {
            statusLight = '<img src="/resource/BPC_Icons/yellow.png" alt="Schedule Status" border="0"/>';
        }

        else if(statusDiffPercent < 90)
        {
            statusLight = '<img src="/resource/BPC_Icons/red.png" alt="Schedule Status" border="0"/>';      
        }

        spendToMarketRows.add(new spendToMarket(targetAnnual, targetMonth, actualMonth, targetYTD, actYTDSpend, statusLight));
    }

    public void createNegSavings(Integer level, String discEntered, String catEntered)
    {
        Id projectID = Schema.SObjectType.PREP_Baseline__c.getRecordTypeInfosByName().get('Projects Baseline').getRecordTypeId();
        Id LprojectID = Schema.SObjectType.PREP_Baseline__c.getRecordTypeInfosByName().get('Locked Projects Baseline').getRecordTypeId();

        negSavingsRows = new List<negSavings>();
        baselineListY = new List<PREP_Baseline__c>();
        baselineListYM = new List<PREP_Baseline__c>();
        baselineListYTD = new List<PREP_Baseline__c>();
        bvsList = new List<PREP_Business_Value_Submission__c>();
        bvsScheList = new List<PREP_Business_Value_Spend_Schedule__c>();
        bvsScheMonthList = new List<PREP_Business_Value_Spend_Schedule_Month__c>();

        iniListY = new List<String>();
        iniListYM = new List<String>();
        iniListYTD = new List<String>();

        Decimal targetAnnual = 0;
        Decimal targetMonth = 0;
        Decimal actualMonth = 0;
        Decimal targetYTD = 0;
        Decimal actYTDSpend = 0;

        Date YTD_Start = date.newinstance(iniYear, 01, 01);
        Date YTD_End;

        if(iniMonth == 12)
        {
            YTD_End = date.newinstance(iniYear+1, 01, 01);
        }

        else
        {
            YTD_End = date.newinstance(iniYear, (iniMonth+1), 01);
        }

        if(level == 0)
        {
            baselineListY = [SELECT Name, RecordTypeId, Baseline_Savings_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Saving_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND CALENDAR_MONTH(Forecast_Date_CAC2__c) = :iniMonth AND CALENDAR_YEAR(Forecast_Date_CAC2__c) = :iniYear AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c WHERE CALENDAR_YEAR(XCAC2_CAC_Award_Approval__c) = :iniYear 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYM = [SELECT Baseline_Savings_Dollar_Target__c, Initiative_Id__c
            FROM PREP_Baseline__c WHERE CALENDAR_YEAR(XCAC2_CAC_Award_Approval__c) = :iniYear 
            AND CALENDAR_MONTH(XCAC2_CAC_Award_Approval__c) = :iniMonth 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Baseline_Savings_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Saving_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND Forecast_Date_CAC2__c >= :YTD_Start AND Forecast_Date_CAC2__c < :YTD_End AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c 
            WHERE XCAC2_CAC_Award_Approval__c >= :YTD_Start AND XCAC2_CAC_Award_Approval__c < :YTD_End 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
        }

        else if(level == 1)
        {

            baselineListY = [SELECT Name, RecordTypeId, Baseline_Savings_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Saving_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND CALENDAR_MONTH(Forecast_Date_CAC2__c) = :iniMonth AND CALENDAR_YEAR(Forecast_Date_CAC2__c) = :iniYear AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND CALENDAR_YEAR(XCAC2_CAC_Award_Approval__c) = :iniYear 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYM = [SELECT Baseline_Savings_Dollar_Target__c, Initiative_Id__c
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND CALENDAR_YEAR(XCAC2_CAC_Award_Approval__c) = :iniYear 
            AND CALENDAR_MONTH(XCAC2_CAC_Award_Approval__c) = :iniMonth 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Baseline_Savings_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Saving_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND Forecast_Date_CAC2__c >= :YTD_Start AND Forecast_Date_CAC2__c < :YTD_End AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND 
            XCAC2_CAC_Award_Approval__c >= :YTD_Start AND XCAC2_CAC_Award_Approval__c < :YTD_End 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

        }

        else if(level == 2)
        {
            baselineListY = [SELECT Name, RecordTypeId, Baseline_Savings_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Saving_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND CALENDAR_MONTH(Forecast_Date_CAC2__c) = :iniMonth AND CALENDAR_YEAR(Forecast_Date_CAC2__c) = :iniYear AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c WHERE CALENDAR_YEAR(XCAC2_CAC_Award_Approval__c) = :iniYear 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYM = [SELECT Baseline_Savings_Dollar_Target__c, Initiative_Id__c
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND Category__c = :catEntered AND 
            CALENDAR_YEAR(XCAC2_CAC_Award_Approval__c) = :iniYear 
            AND CALENDAR_MONTH(XCAC2_CAC_Award_Approval__c) = :iniMonth 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Baseline_Savings_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Saving_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND Forecast_Date_CAC2__c >= :YTD_Start AND Forecast_Date_CAC2__c < :YTD_End AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND Category__c = :catEntered AND 
            XCAC2_CAC_Award_Approval__c >= :YTD_Start AND XCAC2_CAC_Award_Approval__c < :YTD_End 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];            
        }

        for(PREP_Baseline__c baselineY : baselineListY)
        {
            targetAnnual = targetAnnual + baselineY.Baseline_Savings_Dollar_Target__c;
            iniListY.add(baselineY.Initiative_Id__c);
        }

        for(PREP_Baseline__c baselineYM : baselineListYM)
        {
            targetMonth = targetMonth + baselineYM.Baseline_Savings_Dollar_Target__c;
        }



        bvsList = [SELECT Id, Total_Negotiated_Savings__c FROM PREP_Business_Value_Submission__c WHERE CALENDAR_YEAR(Contract_Purchase_Approve_Date__c) = :iniYear 
            AND CALENDAR_MONTH(Contract_Purchase_Approve_Date__c) = :iniMonth AND Initiative_Id__c in :iniListY AND Status__c = 'Approved'];

        if(bvsList.size() > 0)
        {
            for(PREP_Business_Value_Submission__c BVS : bvsList)
            {
                actualMonth = actualMonth + BVS.Total_Negotiated_Savings__c;
            }
        }

        else
        {
            for(PREP_Baseline__c baselineY : baselineListY)
            {
                for(PREP_Initiative_Status_Update__c ISU : baselineY.Material_Group_Status_Summaries__r)
                {
                    actualMonth = actualMonth + ISU.Forecast_Saving_Dollar_Total__c;
                }

                iniListY.add(baselineY.Initiative_Id__c);
            }
        }

        bvsList.clear();

        bvsList = [SELECT Id, Total_Negotiated_Savings__c FROM PREP_Business_Value_Submission__c WHERE Contract_Purchase_Approve_Date__c >= :YTD_Start AND Contract_Purchase_Approve_Date__c < :YTD_End AND Initiative_Id__c in :iniListYTD AND Status__c = 'Approved'];

        if(bvsList.size() > 0)
        {
            for(PREP_Business_Value_Submission__c BVS : bvsList)
            {
                actYTDSpend = actYTDSpend + BVS.Total_Negotiated_Savings__c;
            }
        }

        else
        {
            for(PREP_Baseline__c baselineYTD : baselineListYTD)
            {
                targetYTD = targetYTD + baselineYTD.Baseline_Savings_Dollar_Target__c;

                for(PREP_Initiative_Status_Update__c ISU : baselineYTD.Material_Group_Status_Summaries__r)
                {
                    actYTDSpend = actYTDSpend + ISU.Forecast_Saving_Dollar_Total__c;
                }

                iniListYTD.add(baselineYTD.Initiative_Id__c);
            }
        }

        Decimal statusDiff = (targetYTD - actYTDSpend);
        Decimal sPercent = 0;
        Decimal statusDiffPercent = 0;
        
        if(targetYTD == 0)
        {
            sPercent = 0;
            statusDiffPercent = 100 - (sPercent*100);

        }

        else
        {
            sPercent = (statusDiff / targetYTD);
            statusDiffPercent = 100 - (sPercent*100);

        }
                
        if(statusDiffPercent >= 95)
        {
            statusLight = '<img src="/resource/BPC_Icons/green.png" alt="Schedule Status" border="0"/>';
        }

        else if(statusDiffPercent < 95 && statusDiffPercent >= 90)
        {
            statusLight = '<img src="/resource/BPC_Icons/yellow.png" alt="Schedule Status" border="0"/>';
        }

        else if(statusDiffPercent < 90)
        {
            statusLight = '<img src="/resource/BPC_Icons/red.png" alt="Schedule Status" border="0"/>';      
        }

        negSavingsRows.add(new negSavings(targetAnnual, targetMonth, actualMonth, targetYTD, actYTDSpend, statusLight));

    }

    public void createRealSavings(Integer level, String discEntered, String catEntered)
    {
        Id projectID = Schema.SObjectType.PREP_Baseline__c.getRecordTypeInfosByName().get('Projects Baseline').getRecordTypeId();
        Id LprojectID = Schema.SObjectType.PREP_Baseline__c.getRecordTypeInfosByName().get('Locked Projects Baseline').getRecordTypeId();

        realSavingsRows = new List<realSavings>();
        baselineListY = new List<PREP_Baseline__c>();
        baselineListYM = new List<PREP_Baseline__c>();
        baselineListYTD = new List<PREP_Baseline__c>();
        bvsList = new List<PREP_Business_Value_Submission__c>();
        
        bvsScheList = new List<PREP_Business_Value_Spend_Schedule__c>();
        bvsScheMonthList = new List<PREP_Business_Value_Spend_Schedule_Month__c>();
        bvsScheSavMonthList = new List<PREP_Business_Value_Sav_Schedule_Month__c>();


        bvsIdList = new List<String>();
        bvsScheIdList = new List<String>();
        bvsScheMonthIdList = new List<String>();

        iniListY = new List<String>();
        iniListYM = new List<String>();
        iniListYTD = new List<String>();

        Decimal targetAnnual = 0;
        Decimal targetMonth = 0;
        Decimal actualMonth = 0;
        Decimal targetYTD = 0;
        Decimal actYTDSpend = 0;

        Date YTD_Start = date.newinstance(iniYear, 01, 01);
        Date YTD_End;

        if(iniMonth == 12)
        {
            YTD_End = date.newinstance(iniYear+1, 01, 01);
        }

        else
        {
            YTD_End = date.newinstance(iniYear, (iniMonth+1), 01);
        }


        if(level == 0)
        {
            baselineListY = [SELECT Name, RecordTypeId, Baseline_Savings_Dollar_Target__c, Initiative_Id__c
            FROM PREP_Baseline__c WHERE CALENDAR_YEAR(X07_Contract_Start_Up__c) = :iniYear 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYM = [SELECT Baseline_Savings_Dollar_Target__c, Initiative_Id__c
            FROM PREP_Baseline__c 
            WHERE CALENDAR_YEAR(X07_Contract_Start_Up__c) = :iniYear 
            AND CALENDAR_MONTH(X07_Contract_Start_Up__c) = :iniMonth 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Baseline_Savings_Dollar_Target__c, Initiative_Id__c
            FROM PREP_Baseline__c 
            WHERE X07_Contract_Start_Up__c >= :YTD_Start AND X07_Contract_Start_Up__c < :YTD_End 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
        }

        else if(level == 1)
        {
            baselineListY = [SELECT Name, RecordTypeId, Baseline_Savings_Dollar_Target__c, Initiative_Id__c
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND CALENDAR_YEAR(X07_Contract_Start_Up__c) = :iniYear 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYM = [SELECT Baseline_Savings_Dollar_Target__c, Initiative_Id__c
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND CALENDAR_YEAR(X07_Contract_Start_Up__c) = :iniYear 
            AND CALENDAR_MONTH(X07_Contract_Start_Up__c) = :iniMonth 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Baseline_Savings_Dollar_Target__c, Initiative_Id__c
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND X07_Contract_Start_Up__c >= :YTD_Start AND X07_Contract_Start_Up__c < :YTD_End 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
        }

        else if(level == 2)
        {
            baselineListY = [SELECT Name, RecordTypeId, Baseline_Savings_Dollar_Target__c, Initiative_Id__c
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND Category__c = :catEntered 
            AND CALENDAR_YEAR(X07_Contract_Start_Up__c) = :iniYear 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYM = [SELECT Baseline_Savings_Dollar_Target__c, Initiative_Id__c
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND Category__c = :catEntered AND 
            CALENDAR_YEAR(X07_Contract_Start_Up__c) = :iniYear 
            AND CALENDAR_MONTH(X07_Contract_Start_Up__c) = :iniMonth 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Baseline_Savings_Dollar_Target__c, Initiative_Id__c
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND Category__c = :catEntered AND 
            X07_Contract_Start_Up__c >= :YTD_Start AND X07_Contract_Start_Up__c < :YTD_End 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
        }

        for(PREP_Baseline__c baselineY : baselineListY)
        {

            targetAnnual = targetAnnual + baselineY.Baseline_Savings_Dollar_Target__c;
            iniListY.add(baselineY.Initiative_Id__c);
        }

        for(PREP_Baseline__c baselineYM : baselineListYM)
        {
            targetMonth = targetMonth + baselineYM.Baseline_Savings_Dollar_Target__c;
            iniListYM.add(baselineYM.Initiative_Id__c);
        }

        for(PREP_Baseline__c baselineYTD : baselineListYTD)
        {
            targetYTD = targetYTD + baselineYTD.Baseline_Savings_Dollar_Target__c;
            iniListYTD.add(baselineYTD.Initiative_Id__c);
        }

        bvsList = [SELECT Id FROM PREP_Business_Value_Submission__c WHERE Status__c = 'Approved'];

        for(PREP_Business_Value_Submission__c BVS : bvsList)
        {
            bvsIdList.add(BVS.Id);
        }

        bvsScheList = [SELECT Id FROM PREP_Business_Value_Spend_Schedule__c WHERE Business_Value_Submission_Id__c in :bvsIdList];
        

        for(PREP_Business_Value_Spend_Schedule__c BVSS : bvsScheList)
        {
            bvsScheIdList.add(BVSS.Id);
        }

        bvsScheMonthList = [SELECT Id FROM PREP_Business_Value_Spend_Schedule_Month__c WHERE Business_Value_Spend_Schedule_Id__c in :bvsScheIdList];

        for(PREP_Business_Value_Spend_Schedule_Month__c BVSSM : bvsScheMonthList)
        {
            bvsScheMonthIdList.add(BVSSM.Id);
        }

        bvsScheSavMonthList = [SELECT Id, Year__c, Month_Number__c, Scheduled_Value_Realization__c FROM PREP_Business_Value_Sav_Schedule_Month__c WHERE Current_Value_Classification__c = 'Cost Savings' AND Business_Value_Spend_Schedule_Month_Id__c in :bvsScheMonthIdList];

        for(PREP_Business_Value_Sav_Schedule_Month__c BVSSSM : bvsScheSavMonthList)
        {
            if(BVSSSM.Year__c != null)
            {
                Integer bvssmYear = Integer.valueOf(BVSSSM.Year__c);

                if(bvssmYear == iniYear)
                {
                    targetAnnual = targetAnnual + BVSSSM.Scheduled_Value_Realization__c;
                }
            }
        }


        bvsList.clear();
        bvsScheList.clear();
        bvsScheMonthList.clear();
        bvsScheSavMonthList.clear();

        bvsIdList.clear();
        bvsScheIdList.clear();
        bvsScheMonthIdList.clear();

        bvsList = [SELECT Id FROM PREP_Business_Value_Submission__c WHERE Status__c = 'Approved'];

        for(PREP_Business_Value_Submission__c BVS : bvsList)
        {
            bvsIdList.add(BVS.Id);
        }

        bvsScheList = [SELECT Id FROM PREP_Business_Value_Spend_Schedule__c WHERE Business_Value_Submission_Id__c in :bvsIdList];
        

        for(PREP_Business_Value_Spend_Schedule__c BVSS : bvsScheList)
        {
            bvsScheIdList.add(BVSS.Id);
        }

        bvsScheMonthList = [SELECT Id FROM PREP_Business_Value_Spend_Schedule_Month__c WHERE Business_Value_Spend_Schedule_Id__c in :bvsScheIdList];

        for(PREP_Business_Value_Spend_Schedule_Month__c BVSSM : bvsScheMonthList)
        {
            bvsScheMonthIdList.add(BVSSM.Id);
        }

        bvsScheSavMonthList = [SELECT Id, Name, Year__c, Month_Number__c, Scheduled_Value_Realization__c FROM PREP_Business_Value_Sav_Schedule_Month__c WHERE Current_Value_Classification__c = 'Cost Savings' AND Business_Value_Spend_Schedule_Month_Id__c in :bvsScheMonthIdList];

        for(PREP_Business_Value_Sav_Schedule_Month__c BVSSSM : bvsScheSavMonthList)
        {
            System.debug('Name ' + BVSSSM.Name);
            if(BVSSSM.Year__c != null)
            {
                Integer bvssmYear = Integer.valueOf(BVSSSM.Year__c);

                if(BVSSSM.Month_Number__c == iniMonth && bvssmYear == iniYear)
                {
                    targetMonth = targetMonth + BVSSSM.Scheduled_Value_Realization__c;
                    actualMonth = actualMonth + BVSSSM.Scheduled_Value_Realization__c;
                }
            }
        }

        bvsList.clear();
        bvsScheList.clear();
        bvsScheMonthList.clear();
        bvsScheSavMonthList.clear();

        bvsIdList.clear();
        bvsScheIdList.clear();
        bvsScheMonthIdList.clear();

        bvsList = [SELECT Id FROM PREP_Business_Value_Submission__c WHERE Status__c = 'Approved'];

        for(PREP_Business_Value_Submission__c BVS : bvsList)
        {
            bvsIdList.add(BVS.Id);
        }

        bvsScheList = [SELECT Id FROM PREP_Business_Value_Spend_Schedule__c WHERE Business_Value_Submission_Id__c in :bvsIdList];
                

        for(PREP_Business_Value_Spend_Schedule__c BVSS : bvsScheList)
        {
            bvsScheIdList.add(BVSS.Id);
        }

        bvsScheMonthList = [SELECT Id FROM PREP_Business_Value_Spend_Schedule_Month__c WHERE Business_Value_Spend_Schedule_Id__c in :bvsScheIdList];

        for(PREP_Business_Value_Spend_Schedule_Month__c BVSSM : bvsScheMonthList)
        {
            bvsScheMonthIdList.add(BVSSM.Id);
        }

        bvsScheSavMonthList = [SELECT Id, Year__c, Month_Number__c, Scheduled_Value_Realization__c FROM PREP_Business_Value_Sav_Schedule_Month__c WHERE Current_Value_Classification__c = 'Cost Savings' AND Business_Value_Spend_Schedule_Month_Id__c in :bvsScheMonthIdList];

        for(PREP_Business_Value_Sav_Schedule_Month__c BVSSSM : bvsScheSavMonthList)
        {
            if(BVSSSM.Year__c != null)
            {
                Integer bvssmYear = Integer.valueOf(BVSSSM.Year__c);

                if(BVSSSM.Month_Number__c <= iniMonth && bvssmYear == iniYear)
                {
                    targetYTD = targetYTD + BVSSSM.Scheduled_Value_Realization__c;
                    actYTDSpend = actYTDSpend + BVSSSM.Scheduled_Value_Realization__c;
                }
            }
        }

        Decimal statusDiff = (targetYTD - actYTDSpend);
        Decimal sPercent = 0;
        Decimal statusDiffPercent = 0;

        if(targetYTD == 0)
        {
            sPercent = 0;
            statusDiffPercent = 100 - (sPercent*100);

        }

        else
        {
            sPercent = (statusDiff / targetYTD);
            statusDiffPercent = 100 - (sPercent*100);

        }
        
        if(statusDiffPercent >= 95)
        {
            statusLight = '<img src="/resource/BPC_Icons/green.png" alt="Schedule Status" border="0"/>';
        }

        else if(statusDiffPercent < 95 && statusDiffPercent >= 90)
        {
            statusLight = '<img src="/resource/BPC_Icons/yellow.png" alt="Schedule Status" border="0"/>';
        }

        else if(statusDiffPercent < 90)
        {
            statusLight = '<img src="/resource/BPC_Icons/red.png" alt="Schedule Status" border="0"/>';      
        }

        realSavingsRows.add(new realSavings(targetAnnual, targetMonth, actualMonth, targetYTD, actYTDSpend, statusLight));

    }


    public void createStepOnetoFour(Integer level, String discEntered, String catEntered)
    {
        Id projectID = Schema.SObjectType.PREP_Baseline__c.getRecordTypeInfosByName().get('Projects Baseline').getRecordTypeId();
        Id LprojectID = Schema.SObjectType.PREP_Baseline__c.getRecordTypeInfosByName().get('Locked Projects Baseline').getRecordTypeId();

        stepOnetoFourRows = new List<stepOnetoFour>();
        baselineListY = new List<PREP_Baseline__c>();
        baselineListYTD = new List<PREP_Baseline__c>();

        Decimal targetMonth = 0;
        Decimal actualMonth = 0;
        Decimal targetYTD = 0;
        Decimal actYTDSpend = 0;

        Date YTD_Start = date.newinstance(iniYear, 01, 01);
        Date YTD_End;

        if(iniMonth == 12)
        {
            YTD_End = date.newinstance(iniYear+1, 01, 01);
        }

        else
        {
            YTD_End = date.newinstance(iniYear, (iniMonth+1), 01);
        }

        if(level == 0)
        {
            baselineListY = 
            [SELECT Name, RecordTypeId, Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c 
            FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND 
            ((CALENDAR_MONTH(Forecast_Date_01__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_01__c) = :iniYear) OR
            (CALENDAR_MONTH(Forecast_Date_02__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_02__c) = :iniYear) OR
            (CALENDAR_MONTH(Forecast_Date_03__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_03__c) = :iniYear) OR
            (CALENDAR_MONTH(Forecast_Date_04__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_04__c) = :iniYear) OR
            (CALENDAR_MONTH(Forecast_Date_CAC1__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_CAC1__c) = :iniYear))
            AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1)
            FROM PREP_Baseline__c 
            WHERE 
            ((CALENDAR_YEAR(X01_Segmentation_Team_Selection__c) = :iniYear 
            AND CALENDAR_MONTH(X01_Segmentation_Team_Selection__c) = :iniMonth) OR
            (CALENDAR_YEAR(X02_Business_Requirements__c) = :iniYear 
            AND CALENDAR_MONTH(X02_Business_Requirements__c) = :iniMonth) OR
            (CALENDAR_YEAR(X03_Supplier_Market_Analysis__c) = :iniYear 
            AND CALENDAR_MONTH(X03_Supplier_Market_Analysis__c) = :iniMonth) OR
            (CALENDAR_YEAR(X04_Sourcing_Options__c) = :iniYear 
            AND CALENDAR_MONTH(X04_Sourcing_Options__c) = :iniMonth) OR
            (CALENDAR_YEAR(XCAC1_CAC_Strategy_Approved__c) = :iniYear 
            AND CALENDAR_MONTH(XCAC1_CAC_Strategy_Approved__c) = :iniMonth))
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Name, RecordTypeId, Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c 
            FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND 
            ((Forecast_Date_01__c >= :YTD_Start AND Forecast_Date_01__c < :YTD_End) OR
            (Forecast_Date_02__c >= :YTD_Start AND Forecast_Date_02__c < :YTD_End) OR
            (Forecast_Date_03__c >= :YTD_Start AND Forecast_Date_03__c < :YTD_End) OR
            (Forecast_Date_04__c >= :YTD_Start AND Forecast_Date_04__c < :YTD_End) OR
            (Forecast_Date_CAC1__c >= :YTD_Start AND Forecast_Date_CAC1__c < :YTD_End))
            AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1)
            FROM PREP_Baseline__c 
            WHERE 
            ((X01_Segmentation_Team_Selection__c >= :YTD_Start AND X01_Segmentation_Team_Selection__c < :YTD_End) OR
            (X02_Business_Requirements__c >= :YTD_Start AND X02_Business_Requirements__c < :YTD_End) OR
            (X03_Supplier_Market_Analysis__c >= :YTD_Start AND X03_Supplier_Market_Analysis__c < :YTD_End) OR
            (X04_Sourcing_Options__c >= :YTD_Start AND X04_Sourcing_Options__c < :YTD_End) OR
            (XCAC1_CAC_Strategy_Approved__c >= :YTD_Start AND XCAC1_CAC_Strategy_Approved__c < :YTD_End))
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
        }

        else if(level == 1)
        {
            baselineListY = 
            [SELECT Name, RecordTypeId, Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c 
            FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND 
            ((CALENDAR_MONTH(Forecast_Date_01__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_01__c) = :iniYear) OR
            (CALENDAR_MONTH(Forecast_Date_02__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_02__c) = :iniYear) OR
            (CALENDAR_MONTH(Forecast_Date_03__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_03__c) = :iniYear) OR
            (CALENDAR_MONTH(Forecast_Date_04__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_04__c) = :iniYear) OR
            (CALENDAR_MONTH(Forecast_Date_CAC1__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_CAC1__c) = :iniYear))
            AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1)
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND 
            ((CALENDAR_YEAR(X01_Segmentation_Team_Selection__c) = :iniYear 
            AND CALENDAR_MONTH(X01_Segmentation_Team_Selection__c) = :iniMonth) OR
            (CALENDAR_YEAR(X02_Business_Requirements__c) = :iniYear 
            AND CALENDAR_MONTH(X02_Business_Requirements__c) = :iniMonth) OR
            (CALENDAR_YEAR(X03_Supplier_Market_Analysis__c) = :iniYear 
            AND CALENDAR_MONTH(X03_Supplier_Market_Analysis__c) = :iniMonth) OR
            (CALENDAR_YEAR(X04_Sourcing_Options__c) = :iniYear 
            AND CALENDAR_MONTH(X04_Sourcing_Options__c) = :iniMonth) OR
            (CALENDAR_YEAR(XCAC1_CAC_Strategy_Approved__c) = :iniYear 
            AND CALENDAR_MONTH(XCAC1_CAC_Strategy_Approved__c) = :iniMonth))
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Name, RecordTypeId, Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c 
            FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND 
            ((Forecast_Date_01__c >= :YTD_Start AND Forecast_Date_01__c < :YTD_End) OR
            (Forecast_Date_02__c >= :YTD_Start AND Forecast_Date_02__c < :YTD_End) OR
            (Forecast_Date_03__c >= :YTD_Start AND Forecast_Date_03__c < :YTD_End) OR
            (Forecast_Date_04__c >= :YTD_Start AND Forecast_Date_04__c < :YTD_End) OR
            (Forecast_Date_CAC1__c >= :YTD_Start AND Forecast_Date_CAC1__c < :YTD_End))
            AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1)
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND 
            ((X01_Segmentation_Team_Selection__c >= :YTD_Start AND X01_Segmentation_Team_Selection__c < :YTD_End) OR
            (X02_Business_Requirements__c >= :YTD_Start AND X02_Business_Requirements__c < :YTD_End) OR
            (X03_Supplier_Market_Analysis__c >= :YTD_Start AND X03_Supplier_Market_Analysis__c < :YTD_End) OR
            (X04_Sourcing_Options__c >= :YTD_Start AND X04_Sourcing_Options__c < :YTD_End) OR
            (XCAC1_CAC_Strategy_Approved__c >= :YTD_Start AND XCAC1_CAC_Strategy_Approved__c < :YTD_End))
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
        }

        else if(level == 2)
        {
            baselineListY = 
            [SELECT Name, RecordTypeId, Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c 
            FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND 
            ((CALENDAR_MONTH(Forecast_Date_01__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_01__c) = :iniYear) OR
            (CALENDAR_MONTH(Forecast_Date_02__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_02__c) = :iniYear) OR
            (CALENDAR_MONTH(Forecast_Date_03__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_03__c) = :iniYear) OR
            (CALENDAR_MONTH(Forecast_Date_04__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_04__c) = :iniYear) OR
            (CALENDAR_MONTH(Forecast_Date_CAC1__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_CAC1__c) = :iniYear))
            AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1)
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND Category__c = :catEntered AND 
            ((CALENDAR_YEAR(X01_Segmentation_Team_Selection__c) = :iniYear 
            AND CALENDAR_MONTH(X01_Segmentation_Team_Selection__c) = :iniMonth) OR
            (CALENDAR_YEAR(X02_Business_Requirements__c) = :iniYear 
            AND CALENDAR_MONTH(X02_Business_Requirements__c) = :iniMonth) OR
            (CALENDAR_YEAR(X03_Supplier_Market_Analysis__c) = :iniYear 
            AND CALENDAR_MONTH(X03_Supplier_Market_Analysis__c) = :iniMonth) OR
            (CALENDAR_YEAR(X04_Sourcing_Options__c) = :iniYear 
            AND CALENDAR_MONTH(X04_Sourcing_Options__c) = :iniMonth) OR
            (CALENDAR_YEAR(XCAC1_CAC_Strategy_Approved__c) = :iniYear 
            AND CALENDAR_MONTH(XCAC1_CAC_Strategy_Approved__c) = :iniMonth))
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Name, RecordTypeId, Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c 
            FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND 
            ((Forecast_Date_01__c >= :YTD_Start AND Forecast_Date_01__c < :YTD_End) OR
            (Forecast_Date_02__c >= :YTD_Start AND Forecast_Date_02__c < :YTD_End) OR
            (Forecast_Date_03__c >= :YTD_Start AND Forecast_Date_03__c < :YTD_End) OR
            (Forecast_Date_04__c >= :YTD_Start AND Forecast_Date_04__c < :YTD_End) OR
            (Forecast_Date_CAC1__c >= :YTD_Start AND Forecast_Date_CAC1__c < :YTD_End))
            AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1)
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND Category__c = :catEntered AND 
            ((X01_Segmentation_Team_Selection__c >= :YTD_Start AND X01_Segmentation_Team_Selection__c < :YTD_End) OR
            (X02_Business_Requirements__c >= :YTD_Start AND X02_Business_Requirements__c < :YTD_End) OR
            (X03_Supplier_Market_Analysis__c >= :YTD_Start AND X03_Supplier_Market_Analysis__c < :YTD_End) OR
            (X04_Sourcing_Options__c >= :YTD_Start AND X04_Sourcing_Options__c < :YTD_End) OR
            (XCAC1_CAC_Strategy_Approved__c >= :YTD_Start AND XCAC1_CAC_Strategy_Approved__c < :YTD_End))
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
        }

        for(PREP_Baseline__c baselineY : baselineListY)
        {

            targetMonth = targetMonth + baselineY.Baseline_Spend_Dollar_Target__c;

            for(PREP_Initiative_Status_Update__c ISU : baselineY.Material_Group_Status_Summaries__r)
            {
                actualMonth = actualMonth + ISU.Forecast_Spend_Dollar_Total__c;
            }
        }

        for(PREP_Baseline__c baselineYTD : baselineListYTD)
        {
            targetYTD = targetYTD + baselineYTD.Baseline_Spend_Dollar_Target__c;

            for(PREP_Initiative_Status_Update__c ISU : baselineYTD.Material_Group_Status_Summaries__r)
            {
                actYTDSpend = actYTDSpend + ISU.Forecast_Spend_Dollar_Total__c;
            }
        }

        Decimal statusDiff = (targetYTD - actYTDSpend);
        Decimal sPercent = 0;
        Decimal statusDiffPercent = 0;

        if(targetYTD == 0)
        {
            sPercent = 0;
            statusDiffPercent = 100 - (sPercent*100);

        }

        else
        {
            sPercent = (statusDiff / targetYTD);
            statusDiffPercent = 100 - (sPercent*100);

        }
        
        if(statusDiffPercent >= 95)
        {
            statusLight = '<img src="/resource/BPC_Icons/green.png" alt="Schedule Status" border="0"/>';
        }

        else if(statusDiffPercent < 95 && statusDiffPercent >= 90)
        {
            statusLight = '<img src="/resource/BPC_Icons/yellow.png" alt="Schedule Status" border="0"/>';
        }

        else if(statusDiffPercent < 90)
        {
            statusLight = '<img src="/resource/BPC_Icons/red.png" alt="Schedule Status" border="0"/>';      
        }

        stepOnetoFourRows.add(new stepOnetoFour(targetMonth, actualMonth, targetYTD, actYTDSpend, statusLight));

    }

    public void createStepFive(Integer level, String discEntered, String catEntered)
    {
        Id projectID = Schema.SObjectType.PREP_Baseline__c.getRecordTypeInfosByName().get('Projects Baseline').getRecordTypeId();
        Id LprojectID = Schema.SObjectType.PREP_Baseline__c.getRecordTypeInfosByName().get('Locked Projects Baseline').getRecordTypeId();

        stepFiveRows = new List<stepFive>();
        baselineListY = new List<PREP_Baseline__c>();
        baselineListYTD = new List<PREP_Baseline__c>();
        bvsList = new List<PREP_Business_Value_Submission__c>();
        bvsScheList = new List<PREP_Business_Value_Spend_Schedule__c>();
        bvsScheMonthList = new List<PREP_Business_Value_Spend_Schedule_Month__c>();

        Decimal targetMonth = 0;
        Decimal actualMonth = 0;
        Decimal targetYTD = 0;
        Decimal actYTDSpend = 0;

        Date YTD_Start = date.newinstance(iniYear, 01, 01);
        Date YTD_End;

        if(iniMonth == 12)
        {
            YTD_End = date.newinstance(iniYear+1, 01, 01);
        }

        else
        {
            YTD_End = date.newinstance(iniYear, (iniMonth+1), 01);
        }

        if(level == 0)
        {
            baselineListY = 
            [SELECT Name, RecordTypeId, Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c 
            FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND 
            (CALENDAR_MONTH(Forecast_Date_05__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_05__c) = :iniYear)
            AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1)
            FROM PREP_Baseline__c 
            WHERE 
            ((CALENDAR_YEAR(X05_Going_To_Market__c) = :iniYear 
            AND CALENDAR_MONTH(X05_Going_To_Market__c) = :iniMonth))
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND Forecast_Date_05__c >= :YTD_Start AND Forecast_Date_05__c < :YTD_End AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c 
            WHERE X05_Going_To_Market__c >= :YTD_Start AND X05_Going_To_Market__c < :YTD_End 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
        }

        else if(level == 1)
        {
            baselineListY = 
            [SELECT Name, RecordTypeId, Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c 
            FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND 
            (CALENDAR_MONTH(Forecast_Date_05__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_05__c) = :iniYear)
            AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1)
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND 
            ((CALENDAR_YEAR(X05_Going_To_Market__c) = :iniYear 
            AND CALENDAR_MONTH(X05_Going_To_Market__c) = :iniMonth))
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND Forecast_Date_05__c >= :YTD_Start AND Forecast_Date_05__c < :YTD_End AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND 
            X05_Going_To_Market__c >= :YTD_Start AND X05_Going_To_Market__c < :YTD_End 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
        }

        else if(level == 2)
        {
            baselineListY = 
            [SELECT Name, RecordTypeId, Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c 
            FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND 
            (CALENDAR_MONTH(Forecast_Date_05__c) = :iniMonth AND 
            CALENDAR_YEAR(Forecast_Date_05__c) = :iniYear)
            AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1)
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND Category__c = :catEntered AND
            ((CALENDAR_YEAR(X05_Going_To_Market__c) = :iniYear 
            AND CALENDAR_MONTH(X05_Going_To_Market__c) = :iniMonth))
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND Forecast_Date_05__c >= :YTD_Start AND Forecast_Date_05__c < :YTD_End AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND Category__c = :catEntered AND
            X05_Going_To_Market__c >= :YTD_Start AND X05_Going_To_Market__c < :YTD_End 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
        }

        for(PREP_Baseline__c baselineY : baselineListY)
        {

            targetMonth = targetMonth + baselineY.Baseline_Spend_Dollar_Target__c;

            for(PREP_Initiative_Status_Update__c ISU : baselineY.Material_Group_Status_Summaries__r)
            {
                actualMonth = actualMonth + ISU.Forecast_Spend_Dollar_Total__c;
            }
        }

        for(PREP_Baseline__c baselineYTD : baselineListYTD)
        {
            targetYTD = targetYTD + baselineYTD.Baseline_Spend_Dollar_Target__c;

            for(PREP_Initiative_Status_Update__c ISU : baselineYTD.Material_Group_Status_Summaries__r)
            {
                actYTDSpend = actYTDSpend + ISU.Forecast_Spend_Dollar_Total__c;
            }
        }

        Decimal statusDiff = (targetYTD - actYTDSpend);
        Decimal sPercent = 0;
        Decimal statusDiffPercent = 0;

        if(targetYTD == 0)
        {
            sPercent = 0;
            statusDiffPercent = 100 - (sPercent*100);
        }

        else
        {
            sPercent = (statusDiff / targetYTD);
            statusDiffPercent = 100 - (sPercent*100);
        }
        
        if(statusDiffPercent >= 95)
        {
            statusLight = '<img src="/resource/BPC_Icons/green.png" alt="Schedule Status" border="0"/>';
        }

        else if(statusDiffPercent < 95 && statusDiffPercent >= 90)
        {
            statusLight = '<img src="/resource/BPC_Icons/yellow.png" alt="Schedule Status" border="0"/>';
        }

        else if(statusDiffPercent < 90)
        {
            statusLight = '<img src="/resource/BPC_Icons/red.png" alt="Schedule Status" border="0"/>';      
        }

        stepFiveRows.add(new stepFive(targetMonth, actualMonth, targetYTD, actYTDSpend, statusLight));
    }

    public void createStepSeven(Integer level, String discEntered, String catEntered)
    {
        Id projectID = Schema.SObjectType.PREP_Baseline__c.getRecordTypeInfosByName().get('Projects Baseline').getRecordTypeId();
        Id LprojectID = Schema.SObjectType.PREP_Baseline__c.getRecordTypeInfosByName().get('Locked Projects Baseline').getRecordTypeId();

        stepSevenRows = new List<stepSeven>();
        baselineListY = new List<PREP_Baseline__c>();
        baselineListYTD = new List<PREP_Baseline__c>();
        bvsList = new List<PREP_Business_Value_Submission__c>();
        bvsScheList = new List<PREP_Business_Value_Spend_Schedule__c>();
        bvsScheMonthList = new List<PREP_Business_Value_Spend_Schedule_Month__c>();

        Decimal targetMonth = 0;
        Decimal actualMonth = 0;
        Decimal targetYTD = 0;
        Decimal actYTDSpend = 0;

        Date YTD_Start = date.newinstance(iniYear, 01, 01);
        Date YTD_End;

        if(iniMonth == 12)
        {
            YTD_End = date.newinstance(iniYear+1, 01, 01);
        }

        else
        {
            YTD_End = date.newinstance(iniYear, (iniMonth+1), 01);
        }

        if(level == 0)
        {
            baselineListY = 
            [SELECT Name, RecordTypeId, Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND (CALENDAR_MONTH(Forecast_Date_07__c) = :iniMonth AND CALENDAR_YEAR(Forecast_Date_07__c) = :iniYear) 
            AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1)
            FROM PREP_Baseline__c 
            WHERE (CALENDAR_YEAR(X07_Contract_Start_Up__c) = :iniYear 
            AND CALENDAR_MONTH(X07_Contract_Start_Up__c) = :iniMonth)
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND Forecast_Date_07__c >= :YTD_Start AND Forecast_Date_07__c < :YTD_End AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c 
            WHERE X07_Contract_Start_Up__c >= :YTD_Start AND X07_Contract_Start_Up__c < :YTD_End 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];
        }

        else if(level == 1)
        {
            baselineListY = 
            [SELECT Name, RecordTypeId, Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND (CALENDAR_MONTH(Forecast_Date_07__c) = :iniMonth AND CALENDAR_YEAR(Forecast_Date_07__c) = :iniYear) 
            AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1)
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND 
            (CALENDAR_YEAR(X07_Contract_Start_Up__c) = :iniYear 
            AND CALENDAR_MONTH(X07_Contract_Start_Up__c) = :iniMonth)
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND Forecast_Date_07__c >= :YTD_Start AND Forecast_Date_07__c < :YTD_End AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND 
            X07_Contract_Start_Up__c >= :YTD_Start AND X07_Contract_Start_Up__c < :YTD_End 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];            
        }

        else if(level == 2)
        {
            baselineListY = 
            [SELECT Name, RecordTypeId, Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND (CALENDAR_MONTH(Forecast_Date_07__c) = :iniMonth AND CALENDAR_YEAR(Forecast_Date_07__c) = :iniYear) 
            AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1)
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND Category__c = :catEntered AND
            (CALENDAR_YEAR(X07_Contract_Start_Up__c) = :iniYear 
            AND CALENDAR_MONTH(X07_Contract_Start_Up__c) = :iniMonth)
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];

            baselineListYTD = 
            [SELECT Baseline_Spend_Dollar_Target__c, Initiative_Id__c,
            (SELECT Forecast_Spend_Dollar_Total__c FROM Material_Group_Status_Summaries__r 
            WHERE Update_Date__c < :YTD_End AND Forecast_Date_07__c >= :YTD_Start AND Forecast_Date_07__c < :YTD_End AND Complete__c = true
            ORDER BY Update_Date__c DESC, LastModifiedDate DESC LIMIT 1) 
            FROM PREP_Baseline__c 
            WHERE Discipline__c = :discEntered AND Category__c = :catEntered AND
            X07_Contract_Start_Up__c >= :YTD_Start AND X07_Contract_Start_Up__c < :YTD_End 
            AND RecordTypeId != :projectID AND RecordTypeId != :LprojectID];            
        }

        for(PREP_Baseline__c baselineY : baselineListY)
        {

            targetMonth = targetMonth + baselineY.Baseline_Spend_Dollar_Target__c;

            for(PREP_Initiative_Status_Update__c ISU : baselineY.Material_Group_Status_Summaries__r)
            {
                actualMonth = actualMonth + ISU.Forecast_Spend_Dollar_Total__c;
            }
        }

        for(PREP_Baseline__c baselineYTD : baselineListYTD)
        {
            targetYTD = targetYTD + baselineYTD.Baseline_Spend_Dollar_Target__c;

            for(PREP_Initiative_Status_Update__c ISU : baselineYTD.Material_Group_Status_Summaries__r)
            {
                actYTDSpend = actYTDSpend + ISU.Forecast_Spend_Dollar_Total__c;
            }
        }

        Decimal statusDiff = (targetYTD - actYTDSpend);
        Decimal sPercent = 0;
        Decimal statusDiffPercent = 0;

        if(targetYTD == 0)
        {
            sPercent = 0;
            statusDiffPercent = 100 - (sPercent*100);

        }

        else
        {
            sPercent = (statusDiff / targetYTD);
            statusDiffPercent = 100 - (sPercent*100);
        }
        
        if(statusDiffPercent >= 95)
        {
            statusLight = '<img src="/resource/BPC_Icons/green.png" alt="Schedule Status" border="0"/>';
        }

        else if(statusDiffPercent < 95 && statusDiffPercent >= 90)
        {
            statusLight = '<img src="/resource/BPC_Icons/yellow.png" alt="Schedule Status" border="0"/>';
        }

        else if(statusDiffPercent < 90)
        {
            statusLight = '<img src="/resource/BPC_Icons/red.png" alt="Schedule Status" border="0"/>';      
        }

        stepSevenRows.add(new stepSeven(targetMonth, actualMonth, targetYTD, actYTDSpend, statusLight));

    }


    public class spendToMarket
    {   
        public Decimal targetAnnual {get;set;}
        public Decimal targetMonth {get;set;}
        public Decimal targetYTD {get;set;}
        public Decimal actMonth {get;set;}
        public Decimal actYTD {get;set;}
        public String sLight {get;set;}


        public spendToMarket(Decimal targetAnnual, Decimal targetMonth, Decimal actMonth, Decimal targetYTD, Decimal actYTD, String sLight)
        {
            this.targetAnnual = targetAnnual;
            this.targetMonth = targetMonth;
            this.actMonth = actMonth;
            this.targetYTD = targetYTD;
            this.actYTD = actYTD;
            this.sLight = sLight;
        }
    }

    public class negSavings
    {   
        public Decimal targetAnnual {get;set;}
        public Decimal targetMonth {get;set;}
        public Decimal targetYTD {get;set;}
        public Decimal actMonth {get;set;}
        public Decimal actYTD {get;set;}
        public String sLight {get;set;}


        public negSavings(Decimal targetAnnual, Decimal targetMonth, Decimal actMonth, Decimal targetYTD, Decimal actYTD, String sLight)
        {
            this.targetAnnual = targetAnnual;
            this.targetMonth = targetMonth;
            this.actMonth = actMonth;
            this.targetYTD = targetYTD;
            this.actYTD = actYTD;
            this.sLight = sLight;
        }
    }

    public class realSavings
    {   
        public Decimal targetAnnual {get;set;}
        public Decimal targetMonth {get;set;}
        public Decimal targetYTD {get;set;}
        public Decimal actMonth {get;set;}
        public Decimal actYTD {get;set;}
        public String sLight {get;set;}


        public realSavings(Decimal targetAnnual, Decimal targetMonth, Decimal actMonth, Decimal targetYTD, Decimal actYTD, String sLight)
        {
            this.targetAnnual = targetAnnual;
            this.targetMonth = targetMonth;
            this.actMonth = actMonth;
            this.targetYTD = targetYTD;
            this.actYTD = actYTD;
            this.sLight = sLight;
        }
    }

    public class stepOnetoFour
    {   
        public Decimal targetMonth {get;set;}
        public Decimal targetYTD {get;set;}
        public Decimal actMonth {get;set;}
        public Decimal actYTD {get;set;}
        public String sLight {get;set;}


        public stepOnetoFour(Decimal targetMonth, Decimal actMonth, Decimal targetYTD, Decimal actYTD, String sLight)
        {
            this.targetMonth = targetMonth;
            this.actMonth = actMonth;
            this.targetYTD = targetYTD;
            this.actYTD = actYTD;
            this.sLight = sLight;
        }
    }

    public class stepFive
    {   
        public Decimal targetMonth {get;set;}
        public Decimal targetYTD {get;set;}
        public Decimal actMonth {get;set;}
        public Decimal actYTD {get;set;}
        public String sLight {get;set;}


        public stepFive(Decimal targetMonth, Decimal actMonth, Decimal targetYTD, Decimal actYTD, String sLight)
        {
            this.targetMonth = targetMonth;
            this.actMonth = actMonth;
            this.targetYTD = targetYTD;
            this.actYTD = actYTD;
            this.sLight = sLight;
        }
    }

    public class stepSeven
    {   
        public Decimal targetMonth {get;set;}
        public Decimal targetYTD {get;set;}
        public Decimal actMonth {get;set;}
        public Decimal actYTD {get;set;}
        public String sLight {get;set;}


        public stepSeven(Decimal targetMonth, Decimal actMonth, Decimal targetYTD, Decimal actYTD, String sLight)
        {
            this.targetMonth = targetMonth;
            this.actMonth = actMonth;
            this.targetYTD = targetYTD;
            this.actYTD = actYTD;
            this.sLight = sLight;
        }
    }
}